CREATE OR REPLACE FUNCTION CLASSE_CODTRIBPROD(
   P_CDARVPROD     IN PRODUTO.CDARVPROD%TYPE,
   P_CDEMPRESA     IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_CDINSCMUNI    IN NOTAFISCAL.CDINSCMUNI%TYPE,
   P_TIPO          IN VARCHAR2 DEFAULT 'SUB') RETURN VARCHAR2
AS
   V_CDCLASSERVPADR CODTRIBPRODPADR.CDCLASSERVPADR%TYPE;
BEGIN
   IF P_TIPO = 'SUB' THEN/* SUBITEM DO SERVIO*/
      SELECT CDCLASSERVPADR
        INTO V_CDCLASSERVPADR
        FROM CODTRIBPRODPADR C, PRODUTO P
       WHERE P.CDPRODUTO = C.CDPRODUTO
         AND C.CDEMPRESA  = P_CDEMPRESA
         AND C.CDINSCMUNI = P_CDINSCMUNI
         AND P.CDARVPROD = (SELECT MAX(CDARVPROD)
                              FROM CODTRIBPRODPADR C, PRODUTO P
                             WHERE INSTR(P_CDARVPROD, P.CDARVPROD) = 1
                               AND C.CDEMPRESA  = P_CDEMPRESA
                               AND C.CDINSCMUNI = P_CDINSCMUNI
                               AND P.CDPRODUTO  = C.CDPRODUTO);
   ELSE
      SELECT CDTRIBPRODPADR
        INTO V_CDCLASSERVPADR
        FROM CODTRIBPRODPADR C, PRODUTO P
       WHERE P.CDPRODUTO = C.CDPRODUTO
         AND C.CDEMPRESA  = P_CDEMPRESA
         AND C.CDINSCMUNI = P_CDINSCMUNI
         AND P.CDARVPROD = (SELECT MAX(CDARVPROD)
                              FROM CODTRIBPRODPADR C, PRODUTO P
                             WHERE INSTR(P_CDARVPROD, P.CDARVPROD) = 1
                               AND C.CDEMPRESA  = P_CDEMPRESA
                               AND C.CDINSCMUNI = P_CDINSCMUNI
                               AND P.CDPRODUTO  = C.CDPRODUTO);
   END IF;
   RETURN(V_CDCLASSERVPADR);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CLASSE_CODTRIBPROD','5.67.000'); END;
/